.TH XPERFMON 1 "20 July 1989" "X Version 11"
.SH NAME        
xperfmon - X window system performance monitor
.SH SYNOPSIS
.B xperfmon
[option ...]
.SH DESCRIPTION
.I Xperfmon
continuously displays several system statistics as a set of parallel
line graphs.  The name of the host is displayed in the upper left hand
corner.  The information is scaled so that it fills up the entire window.
While 
.I xperfmon
is running, it is possible to perform certain tasks by pressing keys over
the window:
.PP
.TP 8
.B Q/q:
Quit
.TP 8
.B R: 
Reset graph and timer
.TP 8
.B s: 
Decrease update interval (slower) by a small amount
.TP 8
.B S: 
Decrease update interval (slower) by a large amount
.TP 8
.B f: 
Increase update interval (faster) by a small amount
.TP 8
.B F: 
Increase update interval (faster) by a large amount
.TP 8
.B ?: 
Help
.PP
.I Xperfmon
understands the following options:
.PP
.TP 8
.B =geometry
The xperfmon window is created with the specified
size and location
determined
by the supplied geometry specification.
See \fIX(1)\fP for a full explanation.
.PP
.TP 8
.B host:display
Run \fIxperfmon\fP on a specified display.  Default is local:0.0.
.PP
.TP 8
.B \-rv | -reverse
Reverses the foreground and background colors.
.PP
.TP 8
.B \-fw | -forward
Forces colors to be as specified (rather than reversed).
.PP
.TP 8
.B \-fl | -fill
Fills the space between the graph value and the bottom value
with the foreground color.
.PP
.TP 8
.B \-nf | -nofill
Draws the graph as a line.
.PP
.TP 8
.B \-bd | -color \fIcolor\fP
Sets the border color to \fIcolor\fP.  The default is white.
.PP
.TP 8
.B \-bg | -background \fIcolor\fP
Set the background color to \fIcolor\fP.  The default is black.
.PP
.TP 8
.B \-fg | -foreground \fIcolor\fP
Sets the foreground color to \fIcolor\fP. The default is white.
.PP
.TP 8
.B \-bw | -border \fIpixels\fP
Specify the border width in pixels.  Default is 2.
.PP
.TP 8
.B \-fn | -font \fIfontname\fP
The hostname and labels will be displayed in the specified font.
The default is
\fI6X10\fP.
.PP
.TP 8
.B \-u | -update \fIseconds\fP
Specify the update interval for the graph in seconds.  Default is 1.
.PP
.TP 8
.B \-st | -stepsize \fIpixels\fP
Specify the stepsize of the graph.  Default is one pixel.
.PP
.TP 8
.B \-n | -not \fIstat stat stat...\fP
A list of statistics not to be displayed.  Specifying -n or -not on the 
commandline supercedes any statistics specified up to that time.  All 
subsequent
words on the command line that are statistics will be omited from the 
display.  See immediately below.
.PP
.TP 8
.B 
.I stat stat stat...
A list of statistics to be displayed.  If none are listed, all are displayed.
If any are listed, only those listed are displayed
unless -n or -not has been specified.  Possible statistics are
.B user, 
.B system, 
.B idle, 
.B free, 
.B disk, 
.B interrupts, 
.B input, 
.B output, 
and 
.B collision.
These refer to 
.B User CPU percentage, 
.B System CPU percentage, 
.B Free memory,
.B Disk transfers,
.B Interrupts,
.B Input packets,
.B Output packets,
and
.B Collision packets.
.SH X DEFAULTS
.PP
.TP 8
.B geometry
Specifies the default geometry in standard X notation.
.PP
.TP 8
.B foreground
Specifies the color to use for the window foreground.
.PP
.TP 8
.B background
Specifies the color to use for the window background.
.PP
.TP 8
.B color
Specifies the color to use for the border color.
.PP
.TP 8
.B border
Specifies the width of the border in pixels.
.PP
.TP 8
.B font
Specifies the font to use for the graph labels.
.PP
.TP 8
.B stepsize
Specifies the stepsize of the graph in pixels.
.PP
.TP 8
.B reverse
Specify yes or no.  Specifies if the foregroud and background colors
should be reversed.
.PP
.TP 8
.B update
Specifies the update interval in seconds.
.SH ENVIRONMENT
\fBDISPLAY\fR - to get the default host and display number.
.SH SEE ALSO
X(1), uwm(1), X(8C), mem(4), select(2)
.SH AUTHORS
The X11 version of 
.I xperfmon
was written by Emanuel Jay Berkenbilt, Project Athena on
1/21/1988.  Additional enhancements were added by Ken Sumrall, HP California
Language Labs on 7/20/1989.  There is no record of previous authors.
.SH BUGS
.I Xperfmon
requires the ability to open and read 
.I /dev/kmem. 
On most systems, this requires
the suid bit set with root ownership or the sgid bit set and membership in 
the same group as 
.I /dev/kmem. 
.PP
Occasionally, the 
.I xperfmon 
window will not be updated correctly if its size
changed too many times in rapid succession.  This is a consequence of the 
way that exposure events are handled.
